const {registerBlockType} = wp.blocks; //Blocks API
const {createElement} = wp.element; //React.createElement
const {__} = wp.i18n; //translation functions
const {InspectorControls} = wp.blockEditor; //Block inspector wrapper
const {SelectControl,TextControl,PanelBody,ServerSideRender} = wp.components; //WordPress form inputs and server-side renderer

var sidebars = window.herculesWidgetizedBlock.sidebars;
registerBlockType( 'hercules-blocks/display-widgets', {
	title: __( 'Hercules Display widgets area' ), // Block title.
	icon: 'shortcode',
	category:  __( 'common' ), //category
	attributes:  {
		id : {
		type: 'string',
			default: '',
		},
		cssclass: {
		type: 'string',
			default: ''
		}
	},
	//display the post title
	edit(props){
		const attributes =  props.attributes;
		const setAttributes =  props.setAttributes;
		
var options = [{
        label: __('Select Widgetized Area'),
        value: ''
      }];
		//Function to update id attribute
      if (sidebars && Object.keys(sidebars).length) {
        Object.keys(sidebars).forEach(function (name) {
          options.push({
            label: sidebars[name].name,
            value: sidebars[name].id
          });
        });
      }

		//Function to update heading level
		function changeHeading(cssclass){
			setAttributes({cssclass});
		}

		//Display block preview and UI
		return createElement('div', {}, [
			'Sidebar ID ' + attributes.id,
			//Block inspector
			createElement( InspectorControls, {},
				[

					createElement(SelectControl, {
						value: attributes.id,
						label: __( 'Widgetized Area' ),
						options: options,
						  onChange: function onChange(value) {
          setAttributes({
            id: value
          });
        }
					}),
					//Select cssclass
					createElement(TextControl, {
						value: attributes.cssclass,
						label: __( 'Custom css class' ),
						onChange: changeHeading
					})
				]
			)
		] )
	},
	save(){
		return null;//save has to exist. This all we need
	}
});
