<?php
/*
// =============================== My Recent News ======================================*/
class buzzblogpro_LatestPostsWidget extends WP_Widget {

	public function __construct() {

		$widget_ops = array(
			'classname' => 'buzzblogpro_LatestPostsWidget', 
			'description' => esc_html__('A widget that displays the latest posts', 'buzzblogpro') 
		);
        
		parent::__construct(
			'buzzblogpro_LatestPostsWidget',
			esc_html__('Hercules - Latest Posts', 'buzzblogpro'),
			$widget_ops
		);

	}
/**
 * Displays custom posts widget on blog.
 */
public function widget($argsy, $instance) {
	global $wp_registered_sidebars;
	extract( $argsy );
	$title 	= apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
	
	
	echo wp_kses_post( $argsy['before_widget'] );
	
		 if ( $title ) {
			echo wp_kses_post( $argsy['before_title'] . $title . $argsy['after_title'] );
		} 
$sidebars = $instance['selected_sidebar'];	
$style   = isset($instance['style']) ? $instance['style'] : 'standard';
$specials   = isset($instance['specials']) ? $instance['specials'] : 'hide-specials';
$number  = isset($instance['number']) ? $instance['number'] : '10';
$offset = isset($instance['offset']) ? $instance['offset'] : '0';
$cats = '';
$sidebar_width = buzzblogpro_getVariable('sidebar_width') ? buzzblogpro_getVariable('sidebar_width') : 'smaller';
switch ($sidebar_width) {
		case 'bigger':
			$sidebar_class = '4';
			$main_class = '8';
		break;
		case 'smaller':
			$sidebar_class = '3';
			$main_class = '9';
		break;
	}

		if ( ! isset( $number ) || ! is_numeric( $number ) ): $number = '10'; endif;
		 
	
		$arguments  = array( 'post_type' => 'post', 'posts_per_page' => $number, 'post__not_in' => get_option( 'sticky_posts' ), 'ignore_sticky_posts' => 1, 'suppress_filters' => false, 'post_status' => 'publish' );
						if (class_exists('PLL_Base')) {
$arguments['lang'] = pll_current_language();
}
		$custom_posts = array();
        if (!empty($instance['custom_posts'])) {
            $custom_posts = explode(',', $instance['custom_posts']);
            $custom_posts = array_map('trim', $custom_posts);
            $custom_posts = array_map('intval', $custom_posts);
			$arguments['post__in'] = $custom_posts;
		}
		if (isset($instance['exclude']) && $instance['exclude'] == 'exclude' && isset($instance['widget_categories']) ) {
$cats = $instance['widget_categories'];		
			$arguments['tax_query'] = array (
            array(
            'taxonomy' => 'category',
            'field' => 'slug',
            'terms' => $cats,
            'operator' => 'NOT IN',
           ));
		}
		if (isset($instance['exclude']) && $instance['exclude'] == 'include' && isset($instance['widget_categories'])) {
		
		$cats = $instance['widget_categories'];	
		
$arguments['tax_query'] = array (
            array(
            'taxonomy' => 'category',
            'field' => 'slug',
            'terms' => $cats,
            'operator' => 'IN',
           ));
		}
		
if($offset) {
$arguments['offset'] = $offset;
}
        $counter = 1;
		$i = 1;
		switch ($style) {
		case 'masonry-2':
			$counter_set = '3';
		break;
		case 'list':
			$counter_set = '3';
		break;
		case 'masonry-3':
			$counter_set = '4';
		break;
		case 'masonry-4':
			$counter_set = '5';
		break;
	}
		$latest_posts_query = new WP_Query( $arguments );
		if ( $latest_posts_query->have_posts() ) :
			
			?>
			<?php if ( $sidebars !="" ) { ?>
			<div class="row main-blog-widget">
			<?php if (isset($instance['sidebar_side']) && $instance['sidebar_side'] == 'left') { ?>
			<div class="col-md-<?php echo esc_attr( $main_class); ?> col-md-push-<?php echo esc_attr( $sidebar_class); ?>" id="content">
			<?php }else{ ?>
			<div class="col-md-<?php echo esc_attr( $main_class); ?>">
			<?php } ?>
			<?php } ?>
			
			<?php if ( in_array( $style, array( 'masonry-2', 'masonry-3', 'masonry-4' ) ) ) : wp_enqueue_script('masonry'); ?><div class="grid widget-loop row"><?php endif; ?>
			<?php if ( in_array( $style, array( 'standard' ) ) ) : ?><div class="standard-container"> <?php endif; ?>
			
            <?php if ( in_array( $style, array( 'list', 'zigzag' ) ) ) : ?><div class="list-post row"><?php endif; ?>
			<?php if ( in_array( $style, array( 'metro' ) ) ) : ?><div class="metro-post fullwidth row">  <?php endif; ?>
			<?php /* The loop */
			while ( $latest_posts_query->have_posts() ) : $latest_posts_query->the_post();

			if (isset($instance['do_not_duplicate']) && $instance['do_not_duplicate'] == 'yes') {
			buzzblogpro_do_not_dublicate( get_the_ID() );
			}
			if ($style != 'zigzag' && $style != 'standard' && $style != 'metro' ) {
			if ($counter % $counter_set == 0 && $specials == 'show-specials' ) {
			include( locate_template( 'VC-latest-posts/content-standard.php' ) );
			}else{
				include( locate_template( 'VC-latest-posts/content-' . $style . '.php' ) );
				}
				}else{
				include( locate_template( 'VC-latest-posts/content-' . $style . '.php' ) );
				}
				$counter ++ ; $i++ ;
			endwhile;
			wp_reset_postdata();
			?>
		</div>
		


		<?php else : ?>
	<p><?php esc_html_e( 'Sorry, no posts matched your criteria.', 'buzzblogpro' ); ?></p>
<?php endif; ?>

	<?php if ( $sidebars !="" ) { ?>
	</div>
	<?php if (isset($instance['sidebar_side']) && $instance['sidebar_side'] == 'left') { ?>
	<div class="col-md-<?php echo esc_attr( $sidebar_class); ?> col-md-pull-<?php echo esc_attr( $main_class); ?> sidebar <?php if (isset($instance['sticky_sidebar']) && $instance['sticky_sidebar'] == 'yes') { echo 'sticky-sidebar-widget'; } ?> left">
	<?php }else{ ?>
	<div class="col-md-<?php echo esc_attr( $sidebar_class); ?> sidebar <?php if (isset($instance['sticky_sidebar']) && $instance['sticky_sidebar'] == 'yes') { echo 'sticky-sidebar-widget'; } ?>">
	<?php } ?>
				 <div class="theiaStickySidebar">
                        <?php echo do_shortcode( '[displaywidgets widgetareaid="'.$sidebars.'"]' ); ?>
                    </div></div></div>
					<?php } ?>
		 
<?php
		
	

	echo wp_kses_post( $argsy['after_widget'] );
	
}

/**
 * Form processing.
 */
public function update($new_instance, $old_instance) {
    return $new_instance;
}

/**
 * The configuration form.
 */
public function form($instance) {
  
  
  $defaults = array(
			'title' => '', 'style' => 'standard','specials' => 'hide-specials','number'  => '10', 'offset' => '0', 'widget_categories' => array(), 'selected_sidebar' => '', 'exclude' => 'exclude', 'sidebar_side'=> 'right', 'custom_posts' => '', 'sticky_sidebar'=> 'no', 'do_not_duplicate'=> 'no'
			);
		
		$instance = array_merge($defaults, (array) $instance);
		extract($instance);

  global $wp_registered_sidebars;
  $style_list = esc_attr($instance['style']); 
  $specials_list = esc_attr($instance['specials']);
  $categories = (array)$instance['widget_categories'];
  $exlude_list = esc_attr($instance['exclude']);
  $sidebar_side = esc_attr($instance['exclude']);
  $sidebar_side_list = esc_attr($instance['sidebar_side']);
  $sticky_sidebar_list = esc_attr($instance['sticky_sidebar']);
  $do_not_duplicate_list = esc_attr($instance['do_not_duplicate']);
  
  
?>

  <p>
    <label for="<?php echo esc_attr($this->get_field_id("title")); ?>">
        <?php esc_html_e( 'Title', 'buzzblogpro' ); ?>: </label>
        <input class="widefat" id="<?php echo esc_attr($this->get_field_id("title")); ?>" name="<?php echo esc_attr($this->get_field_name("title")); ?>" type="text" value="<?php echo esc_attr($instance["title"]); ?>" />
   
  </p>

  
 <p>
  <label for="<?php echo esc_attr($this->get_field_id("style")); ?>">
  <?php esc_html_e('Latest Posts Layout', 'buzzblogpro'); ?>: </label>
    <select id="<?php echo esc_attr($this->get_field_id("style")); ?>" name="<?php echo esc_attr($this->get_field_name("style")); ?>">
      <?php
        $style_options = array('standard', 'masonry-2', 'masonry-3', 'masonry-4', 'list', 'zigzag', 'metro');
            foreach ($style_options as $option) {
              echo '<option value="' . $option . '" id="' . $option . '"', $style_list == $option ? ' selected="selected"' : '', '>', $option, '</option>';
            } ?>
    </select>
	<br /><span style="font-size:11px; color:#999;"><?php esc_html_e( 'Select Latest Posts Style', 'buzzblogpro' ); ?></span>
 
</p> 

<p>
  <label for="<?php echo esc_attr($this->get_field_id("specials")); ?>">
  <?php esc_html_e('Special post', 'buzzblogpro'); ?>:</label>
    <select id="<?php echo esc_attr($this->get_field_id("specials")); ?>" name="<?php echo esc_attr($this->get_field_name("specials")); ?>">
      <?php
        $sticky_options = array('hide-specials', 'show-specials');
            foreach ($sticky_options as $option) {
              echo '<option value="' . $option . '" id="' . $option . '"', $specials_list == $option ? ' selected="selected"' : '', '>', $option, '</option>';
            } ?>
    </select>
	<br /><span style="font-size:11px; color:#999;"><?php esc_html_e( 'Do you want to have every third post full width ? Only works for list post and masonry layouts.', 'buzzblogpro' ); ?></span>
  
</p> 
  
  <p>
      <label for="<?php echo esc_attr($this->get_field_id("number")); ?>">
          <?php esc_html_e('Number of posts', 'buzzblogpro'); ?>: </label>
          <input style="text-align: center;" id="<?php echo esc_attr($this->get_field_id("number")); ?>" name="<?php echo esc_attr($this->get_field_name("number")); ?>" type="text" value="<?php echo absint($instance["number"]); ?>" size='4' />
     
</p>
  <p>
      <label for="<?php echo esc_attr($this->get_field_id("offset")); ?>">
          <?php esc_html_e('Offset (number of post to displace or pass over)', 'buzzblogpro'); ?>:</label>
          <input style="text-align: center;" id="<?php echo esc_attr($this->get_field_id("offset")); ?>" name="<?php echo esc_attr($this->get_field_name("offset")); ?>" type="text" value="<?php echo absint($instance["offset"]); ?>" size='4' />
      
</p>
<p>
  <label for="<?php echo esc_attr($this->get_field_id("do_not_duplicate")); ?>">
    <?php esc_html_e( 'Do you want to exclude these posts from the main blog?', 'buzzblogpro' ); ?> </label>
	<select id="<?php echo esc_attr($this->get_field_id("do_not_duplicate")); ?>" name="<?php echo esc_attr($this->get_field_name("do_not_duplicate")); ?>">
      <?php
        $do_not_duplicate_options = array('yes', 'no');
            foreach ($do_not_duplicate_options as $option) {
              echo '<option value="' . $option . '" id="' . $option . '"', $do_not_duplicate_list == $option ? ' selected="selected"' : '', '>', $option, '</option>';
            } ?>
    </select>
 
</p>
<fieldset style="border:1px solid #F1F1F1; padding:10px 10px 10px; margin-bottom:1em;">

			<label for="<?php echo esc_attr($this->get_field_id('custom_posts')); ?>"><?php esc_html_e("Editor's choice:", "buzzblogpro"); ?></label>
				<br />
				<input id="<?php echo esc_attr($this->get_field_id('custom_posts')); ?>" name="<?php echo esc_attr($this->get_field_name('custom_posts')); ?>" class="widefat" type="text" value="<?php echo esc_attr($custom_posts); ?>" />
                <br />
                <span style="color: #999;"><?php esc_html_e('Add IDs, separated by commas, eg. 145, 168, 229', 'buzzblogpro'); ?></span>
			
		
</fieldset>		
<fieldset style="border:1px solid #F1F1F1; padding:10px 10px 0; margin-bottom:1em;">

  <label for="<?php echo esc_attr($this->get_field_id("exclude")); ?>">
    <?php esc_html_e( 'Select categories you want to', 'buzzblogpro' ); ?> </label>
	<select id="<?php echo esc_attr($this->get_field_id("exclude")); ?>" name="<?php echo esc_attr($this->get_field_name("exclude")); ?>">
      <?php
        $exlude_options = array('exclude', 'include');
            foreach ($exlude_options as $option) {
              echo '<option value="' . $option . '" id="' . $option . '"', $exlude_list == $option ? ' selected="selected"' : '', '>', $option, '</option>';
            } ?>
    </select>
 
  
  <ul>
  <?php foreach (get_categories() as $category): ?>
    <li>
      <label></label>
        <input type="checkbox"
             class="checkbox"
             name="<?php echo $this->get_field_name('widget_categories') ?>[]"
             value="<?php echo $category->slug ?>"
             <?php checked(in_array($category->slug, $categories)) ?> />
        <?php echo $category->name ?>
      
    </li>
  <?php endforeach ?>
  </ul> 
</fieldset>	
<fieldset style="border:1px solid #F1F1F1; padding:10px 10px 0; margin-bottom:1em;">
<p>
				<label for="<?php echo esc_attr( $this->get_field_id( 'selected_sidebar' ) ); ?>" title="<?php esc_html_e('Specify the sidebar', 'buzzblogpro'); ?>"><?php esc_html_e( 'Sidebar:', 'buzzblogpro' ); ?></label>
				
				<select id="<?php echo esc_attr( $this->get_field_id( 'selected_sidebar' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'selected_sidebar' ) ); ?>">
					<option value=""<?php selected('', $selected_sidebar); ?>><?php esc_html_e('None', 'buzzblogpro'); ?></option>
					<?php foreach(array_keys($wp_registered_sidebars) as $sidebar) : ?>
					<option value="<?php echo $sidebar; ?>"<?php selected($sidebar, $selected_sidebar); ?>><?php echo $wp_registered_sidebars[$sidebar]["name"]; ?></option>
					<?php endforeach; ?>
				</select>
			</p>
<p>
  <label for="<?php echo esc_attr($this->get_field_id("sidebar_side")); ?>">
    <?php esc_html_e( 'Sidebar side:', 'buzzblogpro' ); ?> </label>
	<select id="<?php echo esc_attr($this->get_field_id("sidebar_side")); ?>" name="<?php echo esc_attr($this->get_field_name("sidebar_side")); ?>">
      <?php
        $sidebar_side_options = array('right', 'left');
            foreach ($sidebar_side_options as $option) {
              echo '<option value="' . $option . '" id="' . $option . '"', $sidebar_side_list == $option ? ' selected="selected"' : '', '>', $option, '</option>';
            } ?>
    </select>
 
</p>
<p>
  <label for="<?php echo esc_attr($this->get_field_id("sticky_sidebar")); ?>">
    <?php esc_html_e( 'Sticky sidebar:', 'buzzblogpro' ); ?></label>
	<select id="<?php echo esc_attr($this->get_field_id("sticky_sidebar")); ?>" name="<?php echo esc_attr($this->get_field_name("sticky_sidebar")); ?>">
      <?php
        $sticky_sidebar_options = array('yes', 'no');
            foreach ($sticky_sidebar_options as $option) {
              echo '<option value="' . $option . '" id="' . $option . '"', $sticky_sidebar_list == $option ? ' selected="selected"' : '', '>', $option, '</option>';
            } ?>
    </select>
  
</p>
</fieldset>
<?php
}
}
?>