<?php
	class buzzblogpro_promoarea_widget extends WP_Widget {

	function __construct() {

		$widget_ops = array(
			'classname' => 'buzzblogpro_promoarea_widget', 
			'description'=> esc_html__('Widget that displays the promo area', 'buzzblogpro') 
		);

		parent::__construct(
			'buzzblogpro_promoarea_widget',
			esc_html__('Hercules - Promo area', 'buzzblogpro'),
			$widget_ops
		);

	}
		
		function widget($args, $instance) {
			extract(array_merge($args , $instance));
			if (isset($promoarea)) {
			$promoarea = ($promoarea=='on')? true: false;
			}else{$promoarea ='';}
			echo wp_kses_post( $args['before_widget'] );
			if ( $title ) {
			echo wp_kses_post( $args['before_title'] . $title . $args['after_title'] );
		} 
			if ($promoarea && function_exists('buzzblogpro_promo_areaslides')) {
			echo ($description_text) ? '<div class="excerpt">'.$description_text.'</div>' : '' ;
			buzzblogpro_promo_areaslides();
			}
			echo wp_kses_post( $args['after_widget'] );
		}


		public function update( $new_instance, $old_instance ) {
			return $new_instance;
		}


		public function form($instance) {
			$defaults = array(
				'title' => '',
				'description_text' => '',
				'promoarea' => ''
			);
			extract(array_merge($defaults, $instance));

			$form_field_type = array(
				'title' => array('type' => 'text', 'class' => 'widefat', 'inline_style' => '',  'title' => esc_html__('Title', 'buzzblogpro'), 'description' => '', 'value' => $title),
				'description_text' => array('type' => 'textarea', 'class' => 'widefat', 'inline_style' => '',  'title' => esc_html__('Description', 'buzzblogpro'), 'description' => esc_html__('Description', 'buzzblogpro'), 'value' => $description_text),
				'promoarea' => array('type' => 'checkbox', 'class' => '', 'inline_style' => '', 'title' => esc_html__('Display promo area?', 'buzzblogpro'), 'description' => '', 'value' => $promoarea)
			);

			$output = '<br /><br />';
			foreach ($form_field_type as $key => $args) {
				$field_id = esc_attr($this->get_field_id($key));
				$field_name = esc_attr($this->get_field_name($key));
				$field_class = $args['class'];
				$field_title = $args['title'];
				$field_description = $args['description'];
				$field_value = $args['value'];
				$field_options = isset($args['value_options']) ? $args['value_options'] : array() ;
				$inline_style = $args['inline_style'] ? 'style="'.$args['inline_style'].'"' : '' ;
				switch ($args['type']) {
					case 'text':
						$output .= '<label '.$inline_style.' for="'.$field_id.'">'.$field_title.': <input '.$inline_style.' class="'.$field_class.'" id="'.$field_id.'" name="'.$field_name.'" type="text" value="'.esc_attr($field_value).'" /></label>';
					break;
					case 'checkbox':
						$checked = isset($instance[$key]) ? 'checked' : '' ;
						$output .= '<label for="'.$field_id.'"><input value="on" '.$inline_style.' class="'.$field_class.'" id="'.$field_id.'" name="'.$field_name.'" type="checkbox" '.$checked.' />'.$field_title.'</label>';
					break;
					case 'textarea':
						$output .= '<textarea class="'.$field_class.'" rows="8" cols="10" id="'.$field_id.'" name="'.$field_name.'">'.$field_value.'</textarea>';
					break;
				}
                if($field_description) {				
				$output .= '<br><small>'.$field_description.'</small>';
				}
				if(!$inline_style) {
				$output .= '<br /><br />';
				}
			}
			
			echo balanceTags($output);
		}
	}
?>