<?php
class Buzzblogpro_mailchimp_widget extends WP_Widget {

	/**
	 * Widget setup.
	 */
	public function __construct() {
		/* Widget settings. */
					$this->defaults = array(
			'title' => '',
			'current_mailing_list' => '',
			'signup_text' => 'Subscribe',
			'enter_first_text' => 'First name',
			'enter_last_text' => 'Last name',
			'enter_email_text' => 'Enter email address',
			'horizontal_layout' => '',
			'consent' => '',
			'subtitle_not_in_line' => '',
			'consent_text' => 'I have read and agree to the <a href="/privacy-policy/" target="blank">Privacy Policy</a>',
			'consent_warning' => esc_html__('Please confirm that you agree with our policies', 'buzzblogpro'),
			'collect_first' => '',
			'collect_last' => '',
			'double_optin' => '',
			'subtitle' => '',
			'success_message' => esc_html__('Subscribed successfully', 'buzzblogpro'),
			'pending_message' => esc_html__('You have successfully subscribed. Confirm the subscription in your mailbox', 'buzzblogpro'),
			'member_exists_message' => esc_html__('You are already subscribed', 'buzzblogpro'),
			'invalid_email' => esc_html__('Email is invalid', 'buzzblogpro')
		);

add_action('wp_ajax_nopriv_buzzblogpro-mailchimp', array($this, 'buzzblogpro_mailchimp_forms'));  
add_action('wp_ajax_buzzblogpro-mailchimp', array($this, 'buzzblogpro_mailchimp_forms')); 

		
		$widget_ops = array( 'classname' => 'buzzblogpro_mailchimp_widget', 'description' => esc_html__('Mailchimp Widget', 'buzzblogpro') );
		/* Widget control settings. */
		$control_ops = array('id_base' => 'buzzblogpro_mailchimp_widget');
		

		/* Create the widget. */
		parent::__construct( 'Buzzblogpro_mailchimp_widget', esc_html__('Hercules - Mailchimp', 'buzzblogpro'), $widget_ops, $control_ops );
	}

	public function widget( $args, $instance ) {
		$instance = wp_parse_args((array) $instance, $this->defaults);
        extract($args);
		echo $args['before_widget'];
		echo ( $instance['title'] != '' ? wp_kses_post( $before_title . $instance['title'] . $after_title ) : '' );
			
			?>	
			<div class="mailchimp-container <?php if (!empty($instance['horizontal_layout'])) { echo 'form-inline';}else{echo 'form-normal';} if (!empty($instance['subtitle_not_in_line'])) {echo ' separate-line';} ?>">
			
							<?php	
					if ($instance['subtitle']) {
				?>	
				<h4 class="buzzblogpro-mc-subtitle"><?php echo stripslashes($instance['subtitle']); ?></h4>
				
				<?php	
					} ?>
					<div class="mailchimp-form-container">
			<form class="buzzblogpro-mc-form black-bg typo-white" method="post">
				
				<?php	
					if (!empty($instance['collect_first'])) { 
				?>
				<div class="form-group">
					<input type="text" placeholder="<?php echo stripslashes($instance['enter_first_text']); ?>" class="form-control first-name" name="buzzblogpro-mc-first_name" />
				</div>
				<?php
					}
					if (!empty($instance['collect_last'])) { 
				?>	
				<div class="form-group">
					<input type="text" placeholder="<?php echo stripslashes($instance['enter_last_text']); ?>" class="form-control last-name" name="buzzblogpro-mc-last_name" />
				</div>
				<?php } ?> 

					<input type="hidden" name="buzzblogpro_mc_listid" value="<?php echo stripslashes($instance['current_mailing_list']); ?>" />
					<input type="hidden" name="buzzblogpro_mc_success" value="<?php echo stripslashes($instance['success_message']); ?>" />
					<input type="hidden" name="buzzblogpro_mc_pending" value="<?php echo stripslashes($instance['pending_message']); ?>" />
					<input type="hidden" name="buzzblogpro_mc_member_exists" value="<?php echo stripslashes($instance['member_exists_message']); ?>" />
					<input type="hidden" name="buzzblogpro_mc_invalid_email" value="<?php echo stripslashes($instance['invalid_email']); ?>" />
					
					<?php if (!empty($instance['double_optin'])) { 
				?>
				
					<input type="hidden" name="buzzblogpro_mc_double_optin" value="double_optin" />
				
				<?php
					} ?>
					<div class="form-group submitcontainer">
					  <input type="text" class="form-control buzzblogpro-mc-email" placeholder="<?php echo stripslashes($instance['enter_email_text']); ?>" name="buzzblogpro-mc-email">
					 
					 <div class="ajax-loader loading"><svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 100 100" enable-background="new 0 0 0 0" xml:space="preserve"> <path fill="#222" d="M73,50c0-12.7-10.3-23-23-23S27,37.3,27,50 M30.9,50c0-10.5,8.5-19.1,19.1-19.1S69.1,39.5,69.1,50"> <animateTransform attributeName="transform" attributeType="XML" type="rotate" dur="0.5s" from="0 50 50" to="360 50 50" repeatCount="indefinite"/> </path></svg></div>
					  
					</div>

					<div class="form-groups">
					<input class="buzzblogpro-mc btn-block" type="submit" value="<?php echo stripslashes($instance['signup_text']); ?>" />
				</div>
				<?php wp_referer_field(); ?>
				
				</form>
<?php
if (!empty($instance['consent'])) { 
				?>	
				<div class="consent-check">
					<input id="checkbox_<?php echo esc_attr($this->id); ?>" type="checkbox" name="buzzblogpro-mc-consent"><label for="checkbox_<?php echo esc_attr($this->id); ?>"><?php echo stripslashes($instance['consent_text']); ?></label>
					
				</div>
				<?php	
					} ?> </div>
				</div>
				<?php
			

		echo $args['after_widget'];
			if(is_active_widget(false, false, $this->id_base, true))
    {
	wp_enqueue_script( 'buzzblogpro-mailchimp-forms', plugin_dir_url( __FILE__ ) . 'js/mailchimp-forms.js', array( 'jquery' ), '1.0', true );
			wp_localize_script( 'buzzblogpro-mailchimp-forms', 'mc_var', array(
			'ajax_url'        => admin_url( 'admin-ajax.php' ),
			'warning_privacy' => $instance['consent_warning'],
		) );
			
 }	
		
		}
	/**
	 * Update the widget settings.
	 */
	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance; 
		
		
		$instance['collect_first'] = strip_tags($new_instance['collect_first']);
		$instance['double_optin'] = strip_tags($new_instance['double_optin']);
		
		$instance['horizontal_layout'] = strip_tags($new_instance['horizontal_layout']);
		
		$instance['consent'] = strip_tags($new_instance['consent']);
		$instance['subtitle_not_in_line'] = strip_tags($new_instance['subtitle_not_in_line']);
		
		
		$instance['consent_text'] = $new_instance['consent_text'];
		$instance['consent_warning'] = $new_instance['consent_warning'];
		

		$instance['collect_last'] = strip_tags($new_instance['collect_last']);
		
		$instance['current_mailing_list'] = strip_tags($new_instance['current_mailing_list']);
		
		$instance['pending_message'] = strip_tags($new_instance['pending_message']);
		$instance['member_exists_message'] = strip_tags($new_instance['member_exists_message']);
		$instance['invalid_email'] = strip_tags($new_instance['invalid_email']);
		
		
		$instance['signup_text'] = strip_tags($new_instance['signup_text']);
		$instance['enter_first_text'] = strip_tags($new_instance['enter_first_text']);
		$instance['enter_last_text'] = strip_tags($new_instance['enter_last_text']);
		$instance['enter_email_text'] = strip_tags($new_instance['enter_email_text']);
		
		$instance['success_message'] = strip_tags($new_instance['success_message']);
		
		$instance['subtitle'] = $new_instance['subtitle'];
		
		$instance['title'] = strip_tags($new_instance['title']);
		
		delete_transient( 'mailchimp_cache-'.$this->id );
		return $instance;
	}
	public function form( $instance ) {
	
		$instance = wp_parse_args((array) $instance, $this->defaults);
		
			?>
					<h3><?php echo  esc_html__('General Settings', 'buzzblogpro');?></h3>
					<!-- Widget Title: Text Input -->
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id( 'buzzblogpro-mc-title' ) ); ?>"><?php esc_html_e('Title:', 'buzzblogpro'); ?></label>
						<input  class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" value="<?php echo esc_attr( $instance['title'] ); ?>" type="text" />
					</p>

					
								<?php
			
			$mainoptions = get_option('buzzblogpro_options');
            $token = empty($mainoptions['mailchimp_apikey']) ? '' : $mainoptions['mailchimp_apikey'];

			if ( $token ) {


$data = get_transient( 'mailchimp_cache-'.$this->id );

	if ( false === $data ) {
		$data = $this->buzzblogpro_mailchimp_request( 'GET', 'lists', array(
					'sort_field' => 'date_created',
					'sort_dir'   => 'DESC',
					'count'      => 1000,
				) );

		
			set_transient( 'mailchimp_cache-'.$this->id, $data, apply_filters( 'null_mailchimp_cache', WEEK_IN_SECONDS ) );
		
	}
				if ( is_array( $data ) && isset( $data['lists'] ) && $data['lists'] ) {
				?>

					<p><label for="<?php echo esc_attr( $this->get_field_id( 'current_mailing_list' ) ); ?>"><?php esc_html_e( 'Select a Mailing List :', 'buzzblogpro' ); ?></label>
						<select class="widefat" name="<?php echo esc_attr( $this->get_field_name( 'current_mailing_list' ) ); ?>" id="<?php echo esc_attr( $this->get_field_name( 'current_mailing_list' ) ); ?>">
							
							<?php foreach ( $data['lists'] as $item ) : 
							$selected = (isset($instance['current_mailing_list']) && $instance['current_mailing_list'] == $item['id']) ? '1' : '';
							?>
								
								
								<option <?php echo ( $selected == '1' ? ' selected="selected" ' : '' ); ?>value="<?php echo esc_attr( $item['id'] ); ?>"><?php echo esc_attr( $item['name'] ); ?></option>
								
							<?php endforeach; ?>
						</select>
					</p>
				<?php
				}
			}
			?>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('signup_text') ); ?>"><?php echo esc_html__('Sign Up Button Text :', 'buzzblogpro'); ?></label>
						<input class="widefat" id="<?php echo esc_attr( $this->get_field_id('signup_text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('signup_text') ); ?>" value="<?php echo esc_attr( $instance['signup_text'] ); ?>" type="text"  />
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('enter_first_text') ); ?>"><?php echo esc_html__('First Name Text :', 'buzzblogpro'); ?></label>
						<input class="widefat" id="<?php echo esc_attr( $this->get_field_id('enter_first_text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('enter_first_text') ); ?>" value="<?php echo esc_attr( $instance['enter_first_text'] ); ?>" type="text"  />
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('enter_last_text') ); ?>"><?php echo esc_html__('Last name Text :', 'buzzblogpro'); ?></label>
						<input class="widefat" id="<?php echo esc_attr( $this->get_field_id('enter_last_text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('enter_last_text') ); ?>" value="<?php echo esc_attr( $instance['enter_last_text'] ); ?>" type="text"  />
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('enter_email_text') ); ?>"><?php echo esc_html__('Enter email Text :', 'buzzblogpro'); ?></label>
						<input class="widefat" id="<?php echo esc_attr( $this->get_field_id('enter_email_text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('enter_email_text') ); ?>" value="<?php echo esc_attr( $instance['enter_email_text'] ); ?>" type="text"  />
					</p>
					
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('horizontal_layout') ); ?>"><input type="checkbox" class="checkbox" id="<?php echo esc_attr($this->get_field_id("horizontal_layout")); ?>" name="<?php echo esc_attr($this->get_field_name("horizontal_layout")); ?>"<?php checked( (bool) $instance["horizontal_layout"], true ); ?> />
						<?php echo esc_html__('Enable horizontal layout ?', 'buzzblogpro'); ?>
						
						</label>
						<br />
						<label for="<?php echo esc_attr( $this->get_field_id('double_optin') ); ?>"><input type="checkbox" class="checkbox" id="<?php echo esc_attr($this->get_field_id("double_optin")); ?>" name="<?php echo esc_attr($this->get_field_name("double_optin")); ?>"<?php checked( (bool) $instance["double_optin"], true ); ?> />
						
						<?php echo esc_html__('Double optin', 'buzzblogpro'); ?>
						</label>
						<br />
						</p>
					<h3><?php echo esc_html__('Personal Information', 'buzzblogpro'); ?></h3>
					<p>
						
						
						<label for="<?php echo esc_attr( $this->get_field_id('collect_first') ); ?>"><input type="checkbox" class="checkbox" id="<?php echo esc_attr($this->get_field_id("collect_first")); ?>" name="<?php echo esc_attr($this->get_field_name("collect_first")); ?>"<?php checked( (bool) $instance["collect_first"], true ); ?> />
						
						
						<?php echo esc_html__('Collect first name.', 'buzzblogpro'); ?></label>
						<br />
						
						<label><input type="checkbox" class="checkbox" id="<?php echo esc_attr($this->get_field_id("collect_last")); ?>" name="<?php echo esc_attr($this->get_field_name("collect_last")); ?>"<?php checked( (bool) $instance["collect_last"], true ); ?> />
						
						<?php echo esc_html__('Collect last name.', 'buzzblogpro'); ?></label>
					</p>
					<h3><?php echo esc_html__('Notifications', 'buzzblogpro'); ?></h3>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('subtitle') ); ?>"><?php echo esc_html__('Sub Title: (HTML tags are allowed)', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('subtitle') ); ?>" name="<?php echo esc_attr( $this->get_field_name('subtitle') ); ?>"><?php echo esc_textarea( $instance['subtitle'] ); ?></textarea>
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('subtitle_not_in_line') ); ?>"><input type="checkbox" class="checkbox" id="<?php echo esc_attr($this->get_field_id("subtitle_not_in_line")); ?>" name="<?php echo esc_attr($this->get_field_name("subtitle_not_in_line")); ?>"<?php checked( (bool) $instance["subtitle_not_in_line"], true ); ?> />
						
						<?php echo esc_html__('Display the subtitle in a separate line.', 'buzzblogpro'); ?>
						</label>
						<br />
						</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('success_message') ); ?>"><?php echo esc_html__('Success Message:', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('success_message') ); ?>" name="<?php echo esc_attr( $this->get_field_name('success_message') ); ?>"><?php echo esc_attr( $instance['success_message'] ); ?></textarea>
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('pending_message') ); ?>"><?php echo esc_html__('Pending Message:', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('pending_message') ); ?>" name="<?php echo esc_attr( $this->get_field_name('pending_message') ); ?>"><?php echo esc_attr( $instance['pending_message'] ); ?></textarea>
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('member_exists_message') ); ?>"><?php echo esc_html__('Member Exists Message:', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('member_exists_message') ); ?>" name="<?php echo esc_attr( $this->get_field_name('member_exists_message') ); ?>"><?php echo esc_attr( $instance['member_exists_message'] ); ?></textarea>
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('invalid_email') ); ?>"><?php echo esc_html__('Invalid Email Message:', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('invalid_email') ); ?>" name="<?php echo esc_attr( $this->get_field_name('invalid_email') ); ?>"><?php echo esc_attr( $instance['invalid_email'] ); ?></textarea>
					</p>
					
					
					
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('consent') ); ?>"><input type="checkbox" class="checkbox" id="<?php echo esc_attr($this->get_field_id("consent")); ?>" name="<?php echo esc_attr($this->get_field_name("consent")); ?>"<?php checked( (bool) $instance["consent"], true ); ?> />
						<?php echo esc_html__('Display consent checkbox ?', 'buzzblogpro'); ?>
						
						</label>
						<br />
						</p>
						<p>
						<label for="<?php echo esc_attr( $this->get_field_id('consent_text') ); ?>"><?php echo esc_html__('Consent text:', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('consent_text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('consent_text') ); ?>"><?php echo esc_textarea( $instance['consent_text'] ); ?></textarea>
					</p>
					<p>
						<label for="<?php echo esc_attr( $this->get_field_id('consent_warning') ); ?>"><?php echo esc_html__('Consent warning:', 'buzzblogpro'); ?></label>
						<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id('consent_warning') ); ?>" name="<?php echo esc_attr( $this->get_field_name('consent_warning') ); ?>"><?php echo esc_textarea( $instance['consent_warning'] ); ?></textarea>
					</p>
						
			<?php
			
		
	}
	

public function buzzblogpro_mailchimp_forms() {

wp_verify_nonce( null );

		if ( isset( $_POST['buzzblogpro_mc_listid'] ) ) { // Input var ok.
			$list_id = sanitize_text_field( wp_unslash( $_POST['buzzblogpro_mc_listid'] ) ); // Input var ok.
		}

		if ( isset( $_POST['buzzblogpro-mc-first_name'] ) ) { // Input var ok.
			$first_name = sanitize_text_field( wp_unslash( $_POST['buzzblogpro-mc-first_name'] ) ); // Input var ok.
		}else{
		$first_name = '';
		}
		
		if ( isset( $_POST['buzzblogpro-mc-last_name'] ) ) { // Input var ok.
			$last_name = sanitize_text_field( wp_unslash( $_POST['buzzblogpro-mc-last_name'] ) ); // Input var ok.
		}else{
		$last_name = '';
		}

		if ( isset( $_POST['buzzblogpro-mc-email'] ) ) { // Input var ok.
			$email = sanitize_email( wp_unslash( $_POST['buzzblogpro-mc-email'] ) ); // Input var ok.
		}

		if ( ! isset( $list_id ) || ! $list_id ) {
			wp_send_json_error( esc_html__( 'Something is wrong with your list ID.', 'buzzblogpro' ) );
		}

		if ( isset( $_POST['buzzblogpro_mc_invalid_email'] ) ) {
            $invalid_email = $_POST['buzzblogpro_mc_invalid_email'];
			}else{
			$invalid_email = esc_html__( 'Email is invalid.', 'buzzblogpro' );
			}
			
		if ( ! isset( $email ) || ! $email || ! filter_var( $email, FILTER_VALIDATE_EMAIL ) ) {
			wp_send_json_error( $invalid_email );
		}

		$mainoptions = get_option('buzzblogpro_options');
        $token = empty($mainoptions['mailchimp_apikey']) ? '' : $mainoptions['mailchimp_apikey'];
      
		if ( $token ) {

			if ( isset( $_POST['buzzblogpro_mc_double_optin'] ) ) {
			 $status = 'pending';
			 } else {
				$status = 'subscribed';
		 	}

			// Request parameters.
			$args = array(
				'email_address' => $email,
				'status'        => $status,
			);

			// If display first name field.
			if ( isset( $first_name ) or isset( $last_name ) ) {
				$args['merge_fields'] = array(
					'FNAME' => $first_name,
					'LNAME' => $last_name,
				);
			}
			if ( isset( $_POST['buzzblogpro_mc_success'] ) ) {
            $success = $_POST['buzzblogpro_mc_success'];
			}else{
			$success = esc_html__( 'You have successfully subscribed.', 'buzzblogpro' );
			}
			if ( isset( $_POST['buzzblogpro_mc_pending'] ) ) {
            $pending = $_POST['buzzblogpro_mc_pending'];
			}else{
			$pending = esc_html__( 'You have successfully subscribed. Confirm the subscription in your mailbox.', 'buzzblogpro' );
			}
			
			if ( isset( $_POST['buzzblogpro_mc_member_exists'] ) ) {
            $member_exists = $_POST['buzzblogpro_mc_member_exists'];
			}else{
			$member_exists = esc_html__( 'You are already subscribed.', 'buzzblogpro' );
			}
		
			$result = $this->buzzblogpro_mailchimp_request( 'POST', "lists/$list_id/members", $args );

			if ( isset( $result['status'] ) && 'subscribed' === $result['status'] ) {

				wp_send_json_success( $success );

			} elseif ( isset( $result['status'] ) && 'pending' === $result['status'] ) {

				wp_send_json_success( $pending );

			} elseif ( isset( $result['title'] ) && 'Member Exists' === $result['title'] ) {

				wp_send_json_error( $member_exists);

			} else {

				if ( isset( $result['status'] ) && isset( $result['detail'] ) && 400 <= $result['status'] ) {
					$result = $result['detail'];
				}

				wp_send_json_error( $result );
			}
		}

}


public function buzzblogpro_mailchimp_headers() {

	$mainoptions = get_option('buzzblogpro_options');
    $token = empty($mainoptions['mailchimp_apikey']) ? '' : $mainoptions['mailchimp_apikey'];

	$headers                  = array();
	$headers['Authorization'] = 'apikey: ' . $token;
	$headers['Accept']        = 'application/json';
	$headers['Content-Type']  = 'application/json';
	$headers['User-Agent']    = 'DrewM/MailChimp-API/3.0 (github.com/drewm/mailchimp-api)';

	return $headers;
}

public function buzzblogpro_mailchimp_request( $http_verb = 'GET', $method, $data = array() ) {
	$mainoptions = get_option('buzzblogpro_options');
    $token = empty($mainoptions['mailchimp_apikey']) ? '' : $mainoptions['mailchimp_apikey'];

	if ( ! $token || false === strpos( $token, '-' ) ) {
		return false;
	}

	$url = 'https://<dc>.api.mailchimp.com/3.0/' . ltrim( $method, '/' );

	list(, $data_center ) = explode( '-', $token );

	$url = str_replace( '<dc>', $data_center, $url );

	$args = array(
		'url'       => $url,
		'method'    => $http_verb,
		'headers'   => $this->buzzblogpro_mailchimp_headers(),
		'timeout'   => 10,
		'sslverify' => true,
	);

	if ( ! empty( $data ) ) {
		if ( in_array( $http_verb, array( 'GET', 'DELETE' ), true ) ) {
			$url = add_query_arg( $data, $url );
		} else {
			$args['body'] = wp_json_encode( $data );
		}
	}

	$args = apply_filters( 'buzzblogpro_mailchimp_http_args', $args, $url );

	$response = wp_remote_request( $url, $args );

	if ( ! is_wp_error( $response ) ) {
		$response = wp_remote_retrieve_body( $response );

		$response = json_decode( $response, true );
	} else {
		echo esc_html__( 'This client has not been approved to access this resource.', 'buzzblogpro' );
	}

	return $response;
}	
}
?>